$(document).ready(function () {
	//#######################################

	const graphArray = [
	["ASPO - Datini", "http://dev.restore.ovi.cnr.it:8890/aspo/datini"], 
	["ASPO - Ospedale", "http://dev.restore.ovi.cnr.it:8890/aspo/ospedale"],
	["ASPO - Marcovaldi", "http://dev.restore.ovi.cnr.it:8890/aspo/marcovaldi"],
	["ASPO - Gettatelli", "http://dev.restore.ovi.cnr.it:8890/aspo/gettatelli"],
	["ASPO - Autori ASPO", "http://dev.restore.ovi.cnr.it:8890/aspo/actors"],
	["MPP - Collezione Martini", "http://dev.restore.ovi.cnr.it:8890/mpp/martini"],
	["MPP - Collezione Ospedale", "http://dev.restore.ovi.cnr.it:8890/mpp/ospedale"],
	["MPP - Collezione Datini", "http://dev.restore.ovi.cnr.it:8890/mpp/datini"],
	["MPP - Autori MPP", "http://dev.restore.ovi.cnr.it:8890/mpp/authors"],
	["OVI - Lettere", "http://dev.restore.ovi.cnr.it:8890/ovi/datini"],
	["Luoghi", "http://dev.restore.ovi.cnr.it:8890/mpp/places"]
	];

	var graph_selector = document.getElementById("graph_selector");

	let x = graphArray.length;

	for(var i=0; i<x; i++) {
		   var opt = document.createElement("option");
		   opt.value= graphArray[i][1];
		   opt.innerHTML = graphArray[i][0]; // whatever property it has

		   // then append it to the select element
		   graph_selector.add(opt);
		}

	const entityArray = [
	["Oggetti fisici", "http://www.cidoc-crm.org/cidoc-crm/E22_Man-Made_Object"],
	["Contenuti Informativi", "http://www.cidoc-crm.org/cidoc-crm/E73_Information_Object"],
	["Titoli", "http://www.cidoc-crm.org/cidoc-crm/E35_Title"],
	["Persone", "http://www.cidoc-crm.org/cidoc-crm/E21_Person"]
	];

	var entity_selector = document.getElementById("entity_selector");

	let y = entityArray.length;

	for(var i=0; i<y; i++) {
		   var opt = document.createElement("option");
		   opt.value= entityArray[i][1];
		   opt.innerHTML = entityArray[i][0]; // whatever property it has

		   // then append it to the select element
		   entity_selector.add(opt);
		}

	var search_name = "";
	var testo = "";

	function autori_retrieveData() {

		search_name = testo;

		var g = document.getElementById("graph_selector");
		var graph = g.value;

		var search_graph = "";

		if (graph != "") {
			search_graph = '<' + graph + '>';
		} else {
			search_graph = '?g';
		}

		var e = document.getElementById("entity_selector");
		var entity = e.value;

		var search_entity = "";

		if (entity != "") {
			search_entity = '<' + entity + '>';
		} else {
			search_entity = '?type';
		}


		//var query='SELECT DISTINCT ?nome WHERE {  ?autore <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> <http://www.cidoc-crm.org/cidoc-crm/E39_Actor> .   ?autore <http://www.cidoc-crm.org/cidoc-crm/P1_is_identified_by> ?nomeid.   ?nomeid <http://www.w3.org/2000/01/rdf-schema#label> ?nome . FILTER regex(?nome, "'+ search_name +'") }' ;
		
		query = 'SELECT DISTINCT '+ search_graph +' AS ?graph ?link ?label ?entity ?object ?objLab WHERE { GRAPH '+ search_graph +' { ?link <http://www.w3.org/2000/01/rdf-schema#label> ?label ; <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> '+ search_entity +' . ?label bif:contains "\'' + search_name + '\'" .} '+ search_entity +' <http://www.w3.org/2000/01/rdf-schema#label> ?entity . FILTER (langMatches( lang(?entity), "en" )) OPTIONAL {?link <http://www.cidoc-crm.org/cidoc-crm/P2_has_type> ?object } OPTIONAL {?link <http://www.cidoc-crm.org/cidoc-crm/P2_has_type> ?link_object . ?link_object <http://www.w3.org/2000/01/rdf-schema#label> ?objLab }} limit 100';
       //query = 'select distinct ?nome ?link where {?link <http://www.w3.org/2000/01/rdf-schema#label> ?nome . ?nome bif:contains "'+ search_name +'"}'

		//query = 'select distinct ?nome where {?nome <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> <http://www.cidoc-crm.org/cidoc-crm/E39_Actor> FILTER regex(?nome, "'+ search_name +'")}';

		var autori_url = 'http://dev.restore.ovi.cnr.it:8890/sparql/?default-graph-uri=&query=' + encodeURIComponent(query) + '&output=json';

		$.ajax({

			url: autori_url + '&callback=?',
			dataType: "json",
			success: function (data) {
				autori_handle_json(data);
			},
			error: function (e) {}
		});

	}

	function autori_handle_json(json) {

		console.log(json); 

		$('#wb_Shape1').text("");
		$('#wb_Image1').text("");

		var i = 0;

		$.each(
			json['results']['bindings'],
			function (index, value) {
				var autore = ""; /*Inserisci VALUE TIPOLOGIA*/

				var tipo = "";
				var button_type = "";

				if (value.hasOwnProperty('object')) {
					if (value['object']['type'] == "literal") {
						tipo = value['object']['value'];
					}
				}

				if (value.hasOwnProperty('objLab')) {
					if (value['objLab']['type'] == "literal") {
						tipo = value['objLab']['value'];
					}
				}

				if (tipo == "lettera" || tipo == "Testo annotato OVI") {
					button_type += '<td><button type="button" id="' + value['link']['value'] + '" class="lettera btn btn-default" alt="lettera" title="' + value['label']['value'] + '"><i class="fa fa-info"></i><p class="btn-text">Info</p></button></td>';
				}

				autore += /*INIZIO DIV*/ '<tr><td style="width: 70%;">' /*DA QUA AUTORE ->*/ +   
				'<div style="width:100%; height:auto; border:transparent;">' + value['graph']['value'] + '<br /><a href="' + value['link']['value'] + '" target="_blank">' + value['label']['value'] + '</a>' + '<br />' + value['entity']['value'] + '</td>' +
				button_type +
				/*DA QUI SCHEDA ->*/'<td><button type="button" id="' + value['link']['value'] + '" class="scheda btn btn-default" alt="scheda" title="' + value['label']['value'] + '"><i class="fa fa-bars"></i><p class="btn-text">Scheda</p></button>' + '</td><td>' +		
				/*DA QUI CITAZIONE ->*/'<button type="button" id="' + value['link']['value'] + '" class="cit btn btn-default" alt="scheda" title="Info"><i class="fa fa-quote-right"></i><p class="btn-text">Citazione</p></button>' + '</td><td>' +
				/*DA QUI HYPERLINK ->*/'<button type="button" id="' + value['link']['value'] + '" class="hyp btn btn-default" alt="scheda" title="Info"><i class="fa fa-link"></i><p class="btn-text">Hyperlink</p></button>' + '</td><td>' +
				/*DA QUI LOD ->*/'<a href="http://dev.restore.ovi.cnr.it/lodlive/?' + value['link']['value'] + '" target="_blank"><button type="button" id="lod ' + value['link']['value'] + '"class="btn btn-default info" alt="scheda" title="Info"><i class="fa fa-share-alt"></i><p class="btn-text">Lod</p></button></a></td>' 
				+ '</tr>';/*FINE DIV*/ 
				i++;

				/*onclick=copy__Text("' + value['link']['value'] + '")*/

				$('#wb_Shape1').append(autore);

			});

		if (i==0) {
			var message = '<tr id="error"><td><p>Questa ricerca non ha prodotto risultati</p></td></tr>';
			$('#wb_Shape1').append(message);
		}

	}

	$('#ClipArt1').click(function () {
		testo = $('input#TextArea1').val();
		autori_retrieveData();
		search_name = "";
	});
  
    $('input#TextArea1').keypress(function(e) {
      var key = e.which;
      if (key == 13) // the enter key code
          {
            $('#ClipArt1').click();
            return false;
          }
    });

	//onlick hyperlink button

	$(document).on("click", ".hyp", function (ev) {

		var link = this.id;
		//alert(nome_autore);
		//$('#myModal').text("");
		$("#myModal").empty();
		$("#myModal").css("display", "block");
		$('#myModal').append("<div class='modal-content'><span class='close'>&times;</span><div id='myInput'>" +
			link + "</div><button id='copy_btn' class='btn btn-primary btn-lg' onclick='myFunction()'>Copia</button>");

		

	});

	$(document).on("click", ".lettera", function (ev) {

		var link = this.id;
		//alert(nome_autore);
		//$('#myModal').text("");
		window.open("lettera.html?link="+this.id);
		

	});

	$(document).on("click", ".close", function (ev) {

		var link = this.id;
		//alert(nome_autore);
		//$('#myModal').text("");
		$("#myModal").css("display", "none");

	});

	$(document).on("click", ".back", function (ev) {

		$("#myTab").css("display", "none");

	});

	$(document).on("click", ".cit", function (ev) {
		
		var author ="RESTORE. smart access to digital heritage and memory"

		var year = new Date().getFullYear()

		var today = new Date();
		var dd = String(today.getDate()).padStart(2, '0');
		var mm = String(today.getMonth() + 1).padStart(2, '0'); //January is 0!
		var yyyy = today.getFullYear();

		today = dd + '/' + mm + '/' + yyyy;

		var link = this.id;
		//alert(nome_autore);
		//$('#myModal').text("");
		$("#myModal").empty();
		$("#myModal").css("display", "block");
		$('#myModal').append("<div class='modal-content'><span class='close'>&times;</span><div id='myInput'>" + 
			author + " " + year + ", accesso effettuato: " + today + ", &lt;" + link + "&gt;</div><button id='copy_btn' class='btn btn-primary btn-lg' onclick='myFunction()'>Copia</button>");

		

	});

	$(document).on("click", ".scheda", function (ev) {

		var link = this.id;
		var title = this.title;

		//alert(nome_autore);
		$("#myTab").empty();
		$("#myTab").css("display", "block");
		$('#myTab').append("<div class='tab-content'><span class='back'>&lt; Indietro</span><br /><h2><a href='" + link + "' target='_blank'>" + title + "</a></h2><div id='tab_container'><h3>Relazioni dirette</h3><br /><table id='info_link' class='table table-hover'></table><br /><table id='info_ico' class='table table-hover'></table><br /><h3>Relazioni inverse</h3><br /><table id='info_obj' class='table table-hover'></table></div></div>");

		/*var query_a = 'SELECT DISTINCT ?label WHERE { {<' + link +
		 '> ?p ?object. OPTIONAL {?object ?property ?label . FILTER(?property = <http://www.w3.org/2004/02/skos/core#prefLabel> || ?property = <http://www.w3.org/2000/01/rdf-schema#label>) FILTER (langMatches( lang(?label), "en" )) } } UNION {<'+ link +
		 '> ?p ?object. OPTIONAL {?p <http://www.w3.org/2000/01/rdf-schema#label> ?propertyLabel .?object <http://www.w3.org/2000/01/rdf-schema#label> ?label } FILTER (?p != <http://www.w3.org/1999/02/22-rdf-syntax-ns#type>) FILTER (langMatches( lang(?propertyLabel), "en" ))  }}';
		*/
		var query_a = 'SELECT DISTINCT ?propLab ?object ?label WHERE {{<' + link + 
		'> ?property ?object. ?property <http://www.w3.org/2000/01/rdf-schema#label> ?propLab . OPTIONAL {?object <http://www.w3.org/2000/01/rdf-schema#label> ?label . } FILTER (?property != <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> && ?property != <http://www.cidoc-crm.org/cidoc-crm/P62_depicts>) FILTER (langMatches( lang(?propLab), "en" ))} UNION {<' + link + 
		'> ?property ?object. ?property <http://www.w3.org/2000/01/rdf-schema#label> ?propLab . OPTIONAL {?object <http://www.w3.org/2000/01/rdf-schema#label> ?label . } FILTER (?property != <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> && ?property != <http://www.w3.org/2000/01/rdf-schema#label>) FILTER(!regex(?property, "cidoc"))}}';
		var object_url_a = 'http://dev.restore.ovi.cnr.it:8890/sparql/?default-graph-uri=&query=' + encodeURIComponent(query_a) + '&output=json';

		var query_b = 'SELECT DISTINCT ?subject ?label ?property ?propertyLabel WHERE {?subject ?property <' + link + 
		'> ; <http://www.w3.org/2000/01/rdf-schema#label> ?label . ?property <http://www.w3.org/2000/01/rdf-schema#label> ?propertyLabel . FILTER (langMatches( lang(?propertyLabel), "en" ))}';
		var object_url_b = 'http://dev.restore.ovi.cnr.it:8890/sparql/?default-graph-uri=&query=' + encodeURIComponent(query_b) + '&output=json';

		var query_c = 'SELECT DISTINCT ?object ?label WHERE {{<' + link + '> <http://www.cidoc-crm.org/cidoc-crm/P62_depicts> ?object . ?object <http://www.w3.org/2000/01/rdf-schema#label> ?label .} UNION {<' + link + 
		'> <http://www.cidoc-crm.org/cidoc-crm/P62_depicts> ?object . ?object <http://www.w3.org/2004/02/skos/core#prefLabel> ?label . FILTER (langMatches(lang(?label), "it" )) }}';
		var object_url_c = 'http://dev.restore.ovi.cnr.it:8890/sparql/?default-graph-uri=&query=' + encodeURIComponent(query_c) + '&output=json';


		$.ajax({//SOGGETTO

			url: object_url_a + '&callback=?',
			dataType: "json",
			success: function (data_a) {
				object_info_a(data_a);
			},
			error: function (e) {}
		});

		$.ajax({//OGGETTO

			url: object_url_b + '&callback=?',
			dataType: "json",
			success: function (data_b) {
				object_info_b(data_b);
			},
			error: function (e) {}
		});

		$.ajax({//ICONCLASS

			url: object_url_c + '&callback=?',
			dataType: "json",
			success: function (data_c) {
				object_info_c(data_c);
			},
			error: function (e) {}
		});
		
	});

	function object_info_a(json) {

		console.log(json); 

		var j = 0;

		$('#info_link').text("");

		$.each(
			json['results']['bindings'],
			function (index, value) {
				var autore_a = "";
				var object = "";
				var object_type = value['object']['type'];
				if (object_type == "typed-literal" || object_type == "literal"){
					object = '<td>'+ value['object']['value'] + '</td>';
				}
				else{
					object = '<td style="width:60%;"><a href="'+ value['object']['value'] +'" target="_blank">'+ value['label']['value'] +'</a></td><td>' +
					'<button type="button" id="' + value['object']['value'] + '" class="scheda btn btn-default" alt="scheda" title="' + value['label']['value'] + '"><i class="fa fa-bars"></i><p class="btn-text">Scheda</p></button></td><td>' +
					'<a href="http://dev.restore.ovi.cnr.it/lodlive/?' + value['object']['value'] + '" target="_blank"><button type="button" id="lod " class="btn btn-default info" alt="scheda" title="Info"><i class="fa fa-share-alt"></i><p class="btn-text">Lod</p></button></a></td>';
				}

				autore_a += /*INIZIO DIV*/ '<tr><td style="width:25%;">' + value['propLab']['value'] + '</td>' + object + '</tr>';/*FINE DIV*/ 

				/*onclick=copy__Text("' + value['link']['value'] + '")*/
				j++;

				$('#info_link').append(autore_a);

			});

		if (j==0) {
			var message_a = '<tr id="error"><td><p>Non sono presenti relazioni dirette per questa risorsa</p></td></tr>';
			$('#info_link').append(message_a);
		}

	}
	
	function object_info_b(json) {

		console.log(json); 

		var k = 0;

		$('#info_obj').text("");

		$.each(
			json['results']['bindings'],
			function (index, value) {

				var autore_b = "";

				autore_b += /*INIZIO DIV*/ '<tr><td style="width:60%;"><a href="' + value['subject']['value'] + '" target="_blank">' + value['label']['value'] + '</a></td><td style="width:25%;">' + value['propertyLabel']['value'] + '</td><td>' + 
				'<button type="button" id="' + value['subject']['value'] + '" class="scheda btn btn-default" alt="scheda" title="' + value['label']['value'] + '"><i class="fa fa-bars"></i><p class="btn-text">Scheda</p></button></td><td>' +
				'<a href="http://dev.restore.ovi.cnr.it/lodlive/?' + value['subject']['value'] + '" target="_blank"><button type="button" id="lod " class="btn btn-default info" alt="scheda" title="Info"><i class="fa fa-share-alt"></i><p class="btn-text">Lod</p></button></a></td></tr>';
				/*FINE DIV*/ 

				k++;
				/*onclick=copy__Text("' + value['link']['value'] + '")*/

				$('#info_obj').append(autore_b);

			});

		if (k==0) {
			var message_b = '<tr id="error"><td><p>Non sono presenti relazioni inverse per questa risorsa</p></td></tr>';
			$('#info_obj').append(message_b);
		}

	}

	function object_info_c(json) {

		console.log(json); 

		$('#info_ico').text("");

		$.each(
			json['results']['bindings'],
			function (index, value) {

				var autore_c = "";

				autore_c += /*INIZIO DIV*/ '<tr><td style="width:25%;">depicts</td><td style="width:60%;"><a href="' + value['object']['value'] + '">' + value['label']['value'] + '</a></td><td>' + 
				'<button type="button" id="' + value['object']['value'] + '" class="scheda btn btn-default" alt="scheda" title="' + value['label']['value'] + '"><i class="fa fa-bars"></i><p class="btn-text">Scheda</p></button></td><td>' +
				'<a href="http://dev.restore.ovi.cnr.it/lodlive/?' + value['object']['value'] + '" target="_blank"><button type="button" id="lod " class="btn btn-default info" alt="scheda" title="Info"><i class="fa fa-share-alt"></i><p class="btn-text">Lod</p></button></a></td></tr>';
				/*FINE DIV*/ 

				/*onclick=copy__Text("' + value['link']['value'] + '")*/

				$('#info_ico').append(autore_c);

			});

	}

	//VISUALIZZAZIONI DATI DELL'AUTORE
	

	//FUNZIONE LETTURA LUNGHEZZA FILE JSON
	/*
	function objLength(obj){
		var i=0;
		for (var x in obj){
		if(obj.hasOwnProperty(x)){
		  i++;
		}
		} 
		return i;
	}
	*/

	//#######################################
});

function copyToClipboard(text) {
    var sampleTextarea = document.createElement("textarea");
    document.body.appendChild(sampleTextarea);
    sampleTextarea.value = text; //save main text in it
    sampleTextarea.select(); //select textarea contenrs
    document.execCommand("copy");
    document.body.removeChild(sampleTextarea);
}

function myFunction(){
    var copy = document.getElementById("myInput");
    copyText = copy.textContent;
    copyToClipboard(copyText);

    //copyToClipboard(copyText.value);
}

